# Vamos a ver que realiza el método Conv2d
# de pytorch con entradas de varios canales

import torch
import torch.nn as nn

# Save to file
X = torch.ones( (3,5,5) )
# print( type( X ) )
# print( X.shape )                

X[1,:,:] = X[1,:,:]*2
X[2,:,:] = X[2,:,:]*3

print( X )

weights = torch.tensor([[1., 1., 1.],
                        [1., 1., 1.],
                        [1., 1., 1.]] )

print( weights.shape )
print( weights )

nb_channels = 3
weights = weights.view(1, 1, 3, 3).repeat(1, nb_channels, 1, 1)

conv = nn.Conv2d(nb_channels, 1, 3, bias=False)

with torch.no_grad():
	conv.weight = nn.Parameter(weights)

output = conv( X )

print( output )
print( output.shape )
